Evanyou Blog 彩带

洛谷P2017 [USACO09DEC]晕牛Dizzy Cows [拓扑排序]

  题目传送门

晕牛Dizzy Cows

题目背景

Hzwer 神犇最近又征服了一个国家,然后接下来却也遇见了一个难题。

题目描述

The cows have taken to racing each other around the farm but they get very dizzy when running in circles, and everyone knows that dizzy cows don't produce any milk. Farmer John wants to convert all of the two-way cow paths in the farm to one-way paths in order to eliminate any 'cycles' and prevent the cows from getting dizzy. A 'cycle' enables a cow to traverse one or more cow paths and arrive back at her starting point, thus completing a loop or circle.

The farm comprises N pastures (1 <= N <= 100,000) conveniently numbered 1..N. M1 (1 <= M1 <= 100,000) one-way cow paths and M2 two-way cow paths (1 <= M2 <= 100,000) connect the pastures. No path directly connects a pasture to itself, although multiple paths might connect two different pastures. A cow may or may not be able to travel between any two given pastures by following a sequence of cow paths.

Your job is to assign a direction to the two-way cow paths such that the entire farm (ultimately with only one-way paths) has no cycles. That is, there should be no sequence of one-way cow paths which leads back to its starting position. The existing one-way cow paths do not form a cycle and should be left as they are.

One-way cow paths run from pasture A_i (1 <= A_i <= N) to pasture B_i (1 <= B_i <= N). Two-way cow paths connect pastures X_i (1 <= X_i <= N) and Y_i (1 <= Y_i <= N).

Consider this example:

1-->2 
|  /| 
| / | 
|/  | 
3<--4 

The cow paths between pastures 1 and 3, 2 and 3, and 2 and 4 are two-way paths. One-way paths connect 1 to 2 and also 4 to 3. One valid way to convert the two-way paths into one-way paths in such a way that there are no cycles would be to direct them from 1 to 3, from 2 to 3, and from 3 to 4:

1-->2 
|  /| 
| / | 
vL  v 
3<--4 

奶牛们发现,在农场里面赛跑是很有趣的一件事.可是她们一旦在农场里面不断地转圈,就 会变得头晕目眩.众所周知,眩晕的奶牛是无法产奶的.于是,农夫约翰想要把他农场里面的双 向道路全部改为单向道路,使得他的农场里面一个圈都没有,以避免他的奶牛们被搞得晕头转 向.如果奶牛可以经过若干条道路回到起点,那么这些道路就称为一个圈.

农场有N(1 < N < 100000)片草地,编号为1到N.这些草地由M1条单向 道路和M2条双向道路连接起来.任何一条道路都不会把一片草地和这篇草地本 身连接起来.但是,任意两片草地之间都可能有多条道路连接.不保证任意两片草地之间都有路 径相连.

你的任务是给所有的双向道路设定一个方向,使得整个农场(只剩下单向道路)最后一个圈都 没有.也就是说,不存在一个单向道路序列的终点和起点重合.数据保证一开始就有的单向道路 中,一个圈都没有.而且一开始就有的单向道路不能改变.

单向道路的起点是草地Ai,终点是草地Bi.双向道路连接草 地Xi,Yi

输入输出格式

输入格式:

 

从 dizzy.in 中输入数据

第一行 3 个整数 n,p1,p2,分别表示点数,有向边的数量,无向边的数量。

第二行起输入 p1 行,每行 2 个整数,a,b,表示 a 到 b 有一条有向边。

接下来输入 p2 行,每行 2 个整数 a,b,表示 a 和 b 中间有一条无向边。

 

输出格式:

 

输出到 dizzy.out 中

对于每条无向边,我们要求按输入顺序输出你定向的结果,也就是如果你输出 a‘b,那

表示你将 a 和 b 中间的无向边定向为 a → b。

注意,也许存在很多可行的解。你只要输出其中任意一个就好。

(注:因为没有spj,我们保证按照常规方法做出的答案一定可以AC)

 

输入输出样例

输入样例#1: 
4 2 3
1 2
4 3
1 3
4 2
3 2
输出样例#1:
1 3
4 2
2 3

  分析:

  有点考思维。

  如果不仔细思考的话其实一开始是看不出拓扑排序的做法的。对于这题,我们实际上只需要去掉多余的无向边就行了,因此我们可以这么做:

  输入有向边的时候记录入度,注意输入无向边的时候不要记录,然后做拓扑排序,如果遇到双向边,我们就标记一下它的反向边,最后只要输出未被标记的无向边就行了。

  Code:

//It is made by HolseLee on 25th Oct 2018
//Luogu.org P2017
#include<queue>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
using namespace std;

const int N=1e5+7;
int n,m1,m2,head[N],cnte,dg[N];
struct Edge {
    int frm,to,type,nxt;
}e[N<<2];
queue<int>q;

inline int read()
{
    char ch=getchar(); int x=0; bool flag=false;
    while( ch<'0' || ch>'9' ) {
        if( ch=='-' ) flag=true; ch=getchar();
    }
    while( ch>='0' && ch<='9' ) {
        x=x*10+ch-'0'; ch=getchar();
    }
    return flag ? -x : x ;
}

inline void add(int x,int y,int z)
{
    e[++cnte].frm=x; e[cnte].to=y;
    e[cnte].type=z; e[cnte].nxt=head[x];
    head[x]=cnte;
}

int main()
{
    n=read(), m1=read(), m2=read();
    int x,y;
    for(int i=1; i<=m1; ++i) {
        x=read(), y=read();
        add(x,y,0); dg[y]++;
    }
    if( !(cnte&1) ) cnte++;
    for(int i=1; i<=m2; ++i) {
        x=read(), y=read();
        add(x,y,1),add(y,x,1);
    }
    for(int i=1; i<=n; ++i) if( !dg[i] ) q.push(i);
    while( !q.empty() ) {
        x=q.front(), q.pop();
        for(int i=head[x]; i; i=e[i].nxt)
        if( e[i].type==0 ) {
            y=e[i].to;
            if( !(--dg[y]) ) q.push(y);
        } else if( e[i].type==1 ) {
            e[i^1].type=2;
        }
    }
    for(int i=1; i<=cnte; ++i)
    if( e[i].type==1 ) printf("%d %d\n",e[i].frm,e[i].to);
    return 0;
}

 

posted @ 2018-10-25 16:35  HolseLee  阅读(323)  评论(0编辑  收藏  举报